/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import java.util.Calendar;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Checkbox;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.api.Comboitem;

import com.rjconsultores.ventaboletos.entidad.Categoria;
import com.rjconsultores.ventaboletos.entidad.GrupoCategoria;
import com.rjconsultores.ventaboletos.service.CategoriaService;
import com.rjconsultores.ventaboletos.service.GrupoCategoriaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;

/**
 *
 * @author Rafius
 */
@Controller("editarCategoriaController")
@Scope("prototype")
public class EditarCategoriaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
    private CategoriaService categoriaService;
    @Autowired
    private GrupoCategoriaService grupoCategoriaService;
    
    private Categoria categoria;
    private MyListbox categoriaList;
    private Button btnApagar;
    private static Logger log = Logger.getLogger(EditarCategoriaController.class);
    private MyTextbox txtNome;
    private Combobox cmbGrupoCategoria;
    
	private Checkbox chkIndemitetermorecusa;

    private List<GrupoCategoria> lsGrupoCategoria;
    
    @Override
    public void doAfterCompose(Component comp) throws Exception {    	
        super.doAfterCompose(comp);
        lsGrupoCategoria = grupoCategoriaService.obtenerTodos();
        categoria = (Categoria) Executions.getCurrent().getArg().get("categoria");
        categoriaList = (MyListbox) Executions.getCurrent().getArg().get("categoriaList");

        if (categoria.getCategoriaId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        } else {
            if (categoria.getCategoriaId() == 1) {
                btnApagar.setVisible(Boolean.FALSE);
                txtNome.setDisabled(Boolean.TRUE);

                Messagebox.show(
                        Labels.getLabel("MSG.noEditabled"),
                        Labels.getLabel("editarCategoriaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            }
        }
         
        chkIndemitetermorecusa.setChecked((categoria.getIndemitetermorecusa() == null) ? false : categoria.getIndemitetermorecusa());

        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNome.getValue();
        try {
            categoria.setActivo(true);
            categoria.setFecmodif(Calendar.getInstance().getTime());
            categoria.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            categoria.setIndemitetermorecusa(chkIndemitetermorecusa.isChecked());
            
            Comboitem grupo = cmbGrupoCategoria.getSelectedItem();
            
            if (grupo != null){
            	categoria.setGrupoCategoria((GrupoCategoria)grupo.getValue());
            }

            /*if (categoria.getCategoriaId() != null) {
                List<Categoria> lsCategoria = categoriaService.buscar(categoria.getDesccategoria());
                if (!lsCategoria.isEmpty()) {
                    Messagebox.show(
                            Labels.getLabel("MSG.Registro.Existe"),
                            Labels.getLabel("editarCategoriaController.window.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                    return;
                }
            }*/

            if (categoria.getCategoriaId() == null) {
                List<Categoria> lsCategoria =
                        categoriaService.buscar(categoria.getDesccategoria().trim());

                if (lsCategoria.isEmpty()) {
                    categoriaService.suscribir(categoria);
                    categoriaList.addItem(categoria);

                    Messagebox.show(
                            Labels.getLabel("editarCategoriaController.MSG.suscribirOK"),
                            Labels.getLabel("editarCategoriaController.window.title"),
                            Messagebox.OK, Messagebox.INFORMATION);
                } else {
                    Messagebox.show(
                            Labels.getLabel("MSG.Registro.Existe"),
                            Labels.getLabel("editarCategoriaController.window.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                }
            } else {
                categoriaService.actualizacion(categoria);
                categoriaList.updateItem(categoria);

                Messagebox.show(
                        Labels.getLabel("editarCategoriaController.MSG.suscribirOK"),
                        Labels.getLabel("editarCategoriaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            }

            closeWindow();
        } catch (Exception ex) {
            log.error("editarCategoriaController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarCategoriaController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) throws InterruptedException {
        
        int resp = Messagebox.show(
                Labels.getLabel("editarCategoriaController.MSG.borrarPergunta"),
                Labels.getLabel("editarCategoriaController.window.title"),
                Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

        if (resp == Messagebox.YES) {

            categoriaService.borrar(categoria);

            Messagebox.show(
                    Labels.getLabel("editarCategoriaController.MSG.borrarOK"),
                    Labels.getLabel("editarCategoriaController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);

            categoriaList.removeItem(categoria);

            closeWindow();
        }
        
    }

    public Categoria getCategoria() {
        return categoria;
    }

    public void setCategoria(Categoria categoria) {
        this.categoria = categoria;
    }

    public MyListbox getCategoriaList() {
        return categoriaList;
    }

    public void setCategoriaList(MyListbox categoriaList) {
        this.categoriaList = categoriaList;
    }

    public CategoriaService getCategoriaService() {
        return categoriaService;
    }

    public void setCategoriaService(CategoriaService categoriaService) {
        this.categoriaService = categoriaService;
    }

	public List<GrupoCategoria> getLsGrupoCategoria() {
		return lsGrupoCategoria;
	}

	public void setLsGrupoCategoria(List<GrupoCategoria> lsGrupoCategoria) {
		this.lsGrupoCategoria = lsGrupoCategoria;
	}
}
